PlotCurve Class Reference

Abstract 2D plot curve class. More...

`#include <PlotCurve.h>`

Inheritance diagram for PlotCurve:

## Public Member Functions

void | enableSideLines (bool on)
| PlotCurve (const QString &name=QString())
int | plotStyle ()
| The plot style of the curve. More...
void | restoreCurveLayout (const QStringList &lst)
QString | saveCurveLayout ()
QString | saveCurveSymbolImage ()
void | setPlotStyle (int s)
void | setSkipSymbolsCount (int count)
| Set the number of symbols not to be drawn: usefull for large data sets. More...
void | setType (int t)
void | setXOffset (double dx)
void | setYOffset (double dy)
bool | sideLinesEnabled ()
int | skipSymbolsCount ()
| Returns the number of symbols not to be drawn. More...
int | type ()
| Sort of rtti() More...
double | xOffset ()
double | yOffset ()

## Protected Member Functions

QwtDoubleRect | boundingRect () const
virtual void | drawCurve (QPainter *p, int style, const QwtScaleMap &xMap, const QwtScaleMap &yMap, int from, int to) const
void | drawSideLines (QPainter *p, const QwtScaleMap &xMap, const QwtScaleMap &yMap, int from, int to) const
void | drawSticks (QPainter *p, const QwtScaleMap &xMap, const QwtScaleMap &yMap, int from, int to) const
virtual void | drawSymbols (QPainter *p, const QwtSymbol &, const QwtScaleMap &xMap, const QwtScaleMap &yMap, int from, int to) const
| Draw symbols. More...

## Protected Attributes

int | d_plot_style
bool | d_side_lines
int | d_skip_symbols
int | d_type
double | d_x_offset
double | d_y_offset

## Detailed Description

Abstract 2D plot curve class.

## Constructor & Destructor Documentation

PlotCurve::PlotCurve | ( | const QString & | name = `QString()` | ) |

## Member Function Documentation

QwtDoubleRect PlotCurve::boundingRect | ( |  | ) | const

protected

References ScaleTransformation::Ln, ScaleTransformation::Log10, ScaleTransformation::Log2, and ScaleEngine::type().

void PlotCurve::drawCurve | ( | QPainter * | p,
|  | int | style,
|  | const QwtScaleMap & | xMap,
|  | const QwtScaleMap & | yMap,
|  | int | from,
|  | int | to
| ) |  | const

protected virtual

Reimplemented in DataCurve.

References d_side_lines, and drawSideLines().

Referenced by DataCurve::drawCurve().

void PlotCurve::drawSideLines | ( | QPainter * | p,
|  | const QwtScaleMap & | xMap,
|  | const QwtScaleMap & | yMap,
|  | int | from,
|  | int | to
| ) |  | const

protected

Referenced by drawCurve(), and DataCurve::drawCurve().

void PlotCurve::drawSticks | ( | QPainter * | painter,
|  | const QwtScaleMap & | xMap,
|  | const QwtScaleMap & | yMap,
|  | int | from,
|  | int | to
| ) |  | const

protected

Draw sticks

Parameters

  painter | Painter
  xMap | x map
  yMap | y map
  from | index of the first point to be painted
  to | index of the last point to be painted

See Also
  draw(), drawCurve(), drawDots()

References d_skip_symbols.

void PlotCurve::drawSymbols | ( | QPainter * | painter,
|  | const QwtSymbol & | symbol,
|  | const QwtScaleMap & | xMap,
|  | const QwtScaleMap & | yMap,
|  | int | from,
|  | int | to
| ) |  | const

protected virtual

Draw symbols.

Parameters

  painter | Painter
  symbol | Curve symbol
  xMap | x map
  yMap | y map
  from | index of the first point to be painted
  to | index of the last point to be painted

See Also
  setSymbol(), draw(), drawCurve()

References d_skip_symbols.

void PlotCurve::enableSideLines | ( | bool | on | ) |

inline

References d_side_lines.

Referenced by Graph::copyCurves(), and Graph::setWaterfallSideLines().

int PlotCurve::plotStyle | ( |  | ) |

inline

The plot style of the curve.

See Also
  Graph::CurveType

References d_plot_style.

Referenced by Graph::saveCurveLayout(), Graph::setCurveStyle(), and Graph::updateCurveLayout().

void PlotCurve::restoreCurveLayout | ( | const QStringList & | lst | ) |

References PatternBox::brushStyle(), Graph::getPenStyle(), and SymbolBox::style().

Referenced by FunctionCurve::restore().

QString PlotCurve::saveCurveLayout | ( |  | ) |

References d_plot_style, PatternBox::patternIndex(), Graph::Spline, SymbolBox::symbolIndex(), and Graph::VerticalSteps.

Referenced by FunctionCurve::saveToString().

QString PlotCurve::saveCurveSymbolImage | ( |  | ) |

References ImageSymbol::imagePath(), and ImageSymbol::pixmap().

Referenced by FunctionCurve::saveToString(), and DataCurve::saveToString().

void PlotCurve::setPlotStyle | ( | int | s | ) |

inline

References d_plot_style.

Referenced by BoxCurve::BoxCurve(), PlotDialog::changePlotType(), Graph::copyCurves(), FunctionCurve::FunctionCurve(), QwtHistogram::init(), ErrorBarsCurve::init(), Graph::insertCurve(), ApplicationWindow::openGraph(), PieCurve::PieCurve(), Graph::plotVectors(), QwtBarCurve::QwtBarCurve(), FunctionCurve::restore(), Graph::setCurveStyle(), and VectorCurve::VectorCurve().

void PlotCurve::setSkipSymbolsCount | ( | int | count | ) |

Set the number of symbols not to be drawn: usefull for large data sets.

References d_skip_symbols.

Referenced by PlotDialog::applyErrorBarFormatToCurve(), and ApplicationWindow::openGraph().

void PlotCurve::setType | ( | int | t | ) |

inline

References d_type.

Referenced by BoxCurve::BoxCurve(), FunctionCurve::FunctionCurve(), QwtHistogram::init(), ErrorBarsCurve::init(), PieCurve::PieCurve(), QwtBarCurve::QwtBarCurve(), and VectorCurve::VectorCurve().

void PlotCurve::setXOffset | ( | double | dx | ) |

inline

References d_x_offset.

void PlotCurve::setYOffset | ( | double | dy | ) |

inline

References d_y_offset.

bool PlotCurve::sideLinesEnabled | ( |  | ) |

inline

References d_side_lines.

Referenced by Graph::copyCurves(), Graph::saveToString(), and MultiLayer::showWaterfallFillDialog().

int PlotCurve::skipSymbolsCount | ( |  | ) |

inline

Returns the number of symbols not to be drawn.

References d_skip_symbols.

Referenced by DataCurve::clone(), ErrorBarsCurve::drawErrorBars(), and PlotDialog::setActiveCurve().

int PlotCurve::type | ( |  | ) |

inline

Sort of rtti()

References d_type.

Referenced by PlotDialog::acceptParams(), Graph::addCurves(), Graph::analysableCurvesList(), PlotDialog::applyBoxWhiskersFormatToLayer(), PlotDialog::applyErrorBarFormatToLayer(), PlotDialog::applyGapToLayer(), PlotDialog::applyLabelsFormatToItem(), PlotDialog::applyLineFormatToLayer(), PlotDialog::applyPercentileFormatToLayer(), ErrorBarsCurve::boundingRect(), Graph::boxCurve(), AssociationsDialog::changePlotAssociation(), RangeSelectorTool::clearMultipleSelection(), Graph::closestCurve(), ErrorBarsCurve::copy(), Graph::copyCurves(), RangeSelectorTool::copyMultipleSelection(), Graph::curveRange(), Graph::dataCurve(), ErrorBarsCurve::direction(), ErrorBarsCurve::drawErrorBars(), LegendWidget::drawSymbol(), Graph::enableDouglasPeukerSpeedMode(), ErrorBarsCurve::ErrorBarsCurve(), SubtractLineTool::finalize(), Graph::functionCurve(), Graph::generateFunctionName(), Graph::guessUniqueCurveLayout(), Graph::initCurveLayout(), LayerItem::insertCurvesList(), PlotDialog::insertTabs(), Graph::legendText(), RangeSelectorTool::mightNeedMultipleSelection(), BaselineDialog::modifyBaseline(), LegendWidget::parse(), ErrorBarsCurve::plotAssociation(), PlotDialog::plotAssociationsDialogClosed(), Graph::print(), Graph::reloadCurvesData(), FunctionCurve::restore(), Graph::saveCurves(), DataCurve::saveToString(), PlotDialog::setActiveCurve(), PlotDialog::setAutomaticBinning(), BoxCurve::setBoxRange(), ErrorBarsCurve::setDirection(), Graph::setGrayScale(), Graph::setIndexedColors(), BoxCurve::setWhiskersRange(), ErrorBarsCurve::setXErrors(), PlotDialog::showBoxStatistics(), CurvesDialog::showCurveBtn(), RangeSelectorTool::showSelectionDialog(), QwtBarCurve::stackedCurvesList(), LegendWidget::symbolsMaxWidth(), Graph::updateCurveNames(), Graph::updateCurvesData(), AxesDialog::updateMinorTicksList(), DataCurve::validCurveType(), and ErrorBarsCurve::xErrors().

double PlotCurve::xOffset | ( |  | ) |

inline

References d_x_offset.

Referenced by RangeSelectorTool::emitStatusText(), and DataPickerTool::setSelection().

double PlotCurve::yOffset | ( |  | ) |

inline

References d_y_offset.

Referenced by RangeSelectorTool::emitStatusText(), and DataPickerTool::setSelection().

## Member Data Documentation

int PlotCurve::d_plot_style

protected

Referenced by plotStyle(), saveCurveLayout(), and setPlotStyle().

bool PlotCurve::d_side_lines

protected

Referenced by drawCurve(), DataCurve::drawCurve(), enableSideLines(), and sideLinesEnabled().

int PlotCurve::d_skip_symbols

protected

Referenced by DataCurve::clone(), ErrorBarsCurve::drawErrorBars(), drawSticks(), drawSymbols(), DataCurve::saveToString(), setSkipSymbolsCount(), and skipSymbolsCount().

int PlotCurve::d_type

protected

Referenced by DataCurve::loadData(), setType(), DataCurve::tableRow(), and type().

double PlotCurve::d_x_offset

protected

Referenced by DataCurve::loadData(), setXOffset(), and xOffset().

double PlotCurve::d_y_offset

protected

Referenced by DataCurve::loadData(), setYOffset(), and yOffset().

The documentation for this class was generated from the following files:

- qtiplot/src/plot2D/PlotCurve.h
- qtiplot/src/plot2D/PlotCurve.cpp